#!/usr/bin/perl -w
# Copyright LJ.  www.ljay.org.uk
# Replace with the IP address of your TiVo:
$host = "192.168.xxx.xxx";
# Replace with the name of your TiVo:
$name = "My TiVo";
# Replace with the directory to store the data files (no final slash)
$opdir = "/usr/local/mrtgscripts";

use IO::Socket;
$url = "/mrtgdata";
$EOL = "\015\012";
$EL = "\012";
$BLANK = $EOL x 2;
$linecount = 0;

$remote = IO::Socket::INET->new( Proto     => "tcp",
                                 PeerAddr  => $host,
                                 PeerPort  => "http(80)",
                               );
unless ($remote) { die "" }
$remote->autoflush(1);
print $remote "GET $url HTTP/1.1" . $BLANK;
while ( <$remote> ) {
 $linecount = $linecount + 1;
 if ($linecount eq 6)      { $temp = $_ }
 elsif ($linecount eq 7 )  { $uptimestr = $_ }
 elsif ($linecount eq 8 )  { $load = $_ }
 elsif ($linecount eq 9 )  { $makingcall = $_ }
 elsif ($linecount eq 10 ) { $diskused = $_ }
 elsif ($linecount eq 11 ) { $recording = $_ }
 elsif ($linecount eq 12 ) { $swapused = $_ }
 elsif ($linecount eq 13 ) { $memfree = $_ }
 elsif ($linecount eq 14 ) { $buffers = $_ }
 elsif ($linecount eq 15 ) { $cached = $_ }
 elsif ($linecount eq 16 ) { $uptime = $_ }
 elsif ($linecount eq 17 ) { $cpuu = $_ }
}
close $remote;

# Load
open(F,">$opdir/tivoload");
  print F $load;
  print F $makingcall;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Used
open(F,">$opdir/tivoused");
  print F $diskused;
  print F $recording;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Swap
open(F,">$opdir/tivoswap");
  print F $swapused;
  print F "0" . $EL;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Memory
open(F,">$opdir/tivomemu");
  print F $memfree;
  print F "0" . $EL;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Buffers
open(F,">$opdir/tivobufr");
  print F $buffers;
  print F $cached;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Uptime
open(F,">$opdir/tivouptm");
  print F $uptime;
  print F "0" . $EL;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# CPU Usage
open(F,">$opdir/tivocpul");
  print F $cpuu;
  print F "0" . $EL;
  print F $uptimestr;
  print F $name . $EL;
close(F);

# Temperature
print $temp;
print "0" . $EL;
print $uptimestr;
print $name . $EL;
